#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1
#include <limits.h>
#include <unistd.h>

static char const prog[]="grabconsole";

static char const dev_console[]="/dev/console";

int main(int argc, char** argv) {
  unsigned long fd;
  unsigned int len;
  if (argc!=2)
    die4x(111, prog, usage, prog, " fd");
  len=scan_ulong(argv[1], &fd);
  if (len==0 || argv[1][len]!='\0')
    die6x(111, prog, fatal, arg_fd, err_malformed, err_, argv[1]);
  if (fd>INT_MAX)
    die5x(111, prog, fatal, arg_fd, err_oflow, t_int);
  switch (grabconsole(fd)) {
    case grabconsole_success:
      _exit(0);
    case grabconsole_ioctl:
      die5sys(111, prog, fatal, err_unable, "do ioctl", err_);
    case grabconsole_devconsole_open:
      die6sys(111, prog, fatal, err_unable, err_open, dev_console, err_);
    case grabconsole_devconsole_close:
      die6sys(111, prog, fatal, err_unable, err_close, dev_console, err_);
    default:
      die4sys(111, prog, fatal, err_unknown, err_);
  }
}
